function getCheckedValuesByName(checkboxname) {
   var e=document.getElementsByName(checkboxname);
   var p="";

   for (var j=0;j<e.length;j++) {
      if (e[j].checked) p+=e[j].value+" ";
   };
   return p;
}

function checkAllBoxes(checkboxname,checked) {
   var e=document.getElementsByName(checkboxname);

   for (var j=0;j<e.length;j++) {
      e[j].checked=checked;
   };
}

function getSelectedValueById(selectname,idx) {
   if (idx == undefined) idx = 0;
   var i=document.getElementById(selectname).selectedIndex;
   return document.getElementById(selectname).options[i+idx].value;
}

function checkEnter(event) {
   event=event || window.event;
   getEvent=event.keyCode;
   if (getEvent == "13") {
      return true;
   }
   return false;
}

function checkMinLength(st,len) {
   if (st.length >= len) return true;
   return false;
   return false;
}

function suggestSpecName(url) {
   var version="";
   var url=document.getElementById("speccreateurl").value;
   if (url.indexOf('?') > 0) url=url.substring(0,url.indexOf('?'));
   var specname=url.substring(url.lastIndexOf('/')+1);
   var extension;
   while (i=specname.lastIndexOf('.')) {
      e=specname.substring(i);
      if (e != ".tar" && e != ".gz" && e != ".zip" && e != ".bz2" &&
          e != ".xz" && e != ".tgz" && e != ".zip" && e != ".src" &&
          e != ".orig" && e != ".gem" ) break;
      extension=specname.substring(i+1);
      specname=specname.substring(0,i);
   }
   i=specname.lastIndexOf('_');
   e=specname.substring(i);
   if (e == "_src" || e == "_orig") specname=specname.substring(0,i);
   i=specname.lastIndexOf('-');
   e=specname.substring(i);
   if (e == "-src" || e == "-orig") specname=specname.substring(0,i);
   if (specname.lastIndexOf('-') > 0) {
      version=specname.substring(specname.lastIndexOf('-')+1);
      specname=specname.substring(0,specname.lastIndexOf('-'));
   } else if (specname.lastIndexOf('_') > 0) {
      version=specname.substring(specname.lastIndexOf('_')+1);
      specname=specname.substring(0,specname.lastIndexOf('_'));
   }
   document.getElementById("speccreateurl").value=url;
   if (url.search("cpan.org") >= 0) {
      specname="perl-"+specname;
   } else if (url.search("haskell.org") >= 0) {
      specname="ghc-"+specname;
   } else if (extension == "gem") {
      specname="ruby-"+specname;
   } else {
      specname=specname.toLowerCase();
   }
   if ((url.search("git://") >= 0) || (url.indexOf(".git", url.length - 4) != -1)) {
      document.getElementById("speccreategitbranch").disabled=false;
   } else {
      document.getElementById("speccreategitbranch").disabled=true;
      document.getElementById("speccreateversion").value=version;
   }
   if (url.indexOf(".git", url.length - 4) != -1) {
      document.getElementById("speccreategitbranch").value="master";
      specname=specname.substring(0,specname.lastIndexOf('.git'));   
   }
   document.getElementById("speccreatename").value=specname;
   if (url) {
      document.getElementById("speccreatename").disabled=false;
      document.getElementById("speccreateversion").disabled=false;
      document.getElementById("speccreatetype").disabled=false;
      document.getElementById("speccreatebutton").disabled=false;
   } else {
      document.getElementById("speccreatename").disabled=true;
      document.getElementById("speccreateversion").disabled=true;
      document.getElementById("speccreatetype").disabled=true;
      document.getElementById("speccreatebutton").disabled=true;
   }
   if (extension == "gem") {
      for (var j=0;j<document.getElementById("speccreatetype").length;j++) {
         if (document.getElementById("speccreatetype").options[j].value == "ruby")
            document.getElementById("speccreatetype").options[j].selected=true;
      };
   } else  if (specname.search("perl-") >= 0) {
      for (var j=0;j<document.getElementById("speccreatetype").length;j++) {
         if (document.getElementById("speccreatetype").options[j].value == "perl")
            document.getElementById("speccreatetype").options[j].selected=true;
      };
   } else if ((specname.search("python-") >= 0) || (specname.substring(0,2) == "py")) {
      for (var j=0;j<document.getElementById("speccreatetype").length;j++) {
         if (document.getElementById("speccreatetype").options[j].value == "python")
            document.getElementById("speccreatetype").options[j].selected=true;
      };
   } else if (specname.substring(0,4) == "ghc-") {
      for (var j=0;j<document.getElementById("speccreatetype").length;j++) {
         if (document.getElementById("speccreatetype").options[j].value == "ghc")
            document.getElementById("speccreatetype").options[j].selected=true;
      };
   } else if (url.search("kde.org") >= 0) {
      for (var j=0;j<document.getElementById("speccreatetype").length;j++) {
         if (document.getElementById("speccreatetype").options[j].value == "kde4")
            document.getElementById("speccreatetype").options[j].selected=true;
      };
   } else {
      for (var j=0;j<document.getElementById("speccreatetype").length;j++) {
         if (document.getElementById("speccreatetype").options[j].value == "library")
            document.getElementById("speccreatetype").options[j].selected=true;
      };
   }
}

function replaceHTML(el, html) {
	var oldEl = typeof el === "string" ? document.getElementById(el) : el;
	/*@cc_on // Pure innerHTML is slightly faster in IE
		oldEl.innerHTML = html;
		return oldEl;
	@*/
	var newEl = oldEl.cloneNode(false);
	newEl.innerHTML = html;
	oldEl.parentNode.replaceChild(newEl, oldEl);
	/* Since we just removed the old element from the DOM, return a reference
	to the new element, which can be used to restore variable references. */
	return newEl;
};

function getDownload(request) {
  var url = "/cgi-bin/webbuild"

  if (request != "")
     request=request+"&USER="+user+"&USER_EMAIL="+user_email+"&SECRET="+encodeURIComponent(secret);
  else
     request="USER="+user+"&USER_EMAIL="+user_email+"&SECRET="+encodeURIComponent(secret);

  url = url + "?" + request;

//  var hiddenIFrameID = 'hiddenDownloader', iframe = document.getElementById(hiddenIFrameID);
//  if (iframe == null) {
     iframe = document.createElement('iframe');
//     iframe.id = hiddenIFrameID;
     iframe.style.display = 'none';
//  }
  iframe.src = url;
  document.body.appendChild(iframe);
}

// ajaxFileUpload

jQuery.extend({
	

    createUploadIframe: function(id, uri)
	{
			//create frame
            var frameId = 'jUploadFrame' + id;
            var iframeHtml = '<iframe id="' + frameId + '" name="' + frameId + '" style="position:absolute; top:-9999px; left:-9999px"';
			if(window.ActiveXObject)
			{
                if(typeof uri== 'boolean'){
					iframeHtml += ' src="' + 'javascript:false' + '"';

                }
                else if(typeof uri== 'string'){
					iframeHtml += ' src="' + uri + '"';

                }	
			}
			iframeHtml += ' />';
			jQuery(iframeHtml).appendTo(document.body);

            return jQuery('#' + frameId).get(0);			
    },
    createUploadForm: function(id, fileElementId, data)
	{
		//create form	
		var formId = 'jUploadForm' + id;
		var fileId = 'jUploadFile' + id;
		var form = jQuery('<form  action="" method="POST" name="' + formId + '" id="' + formId + '" enctype="multipart/form-data"></form>');	
		if(data)
		{
			for(var i in data)
			{
				jQuery('<input type="hidden" name="' + i + '" value="' + data[i] + '" />').appendTo(form);
			}			
		}		
		var oldElement = jQuery('#' + fileElementId);
		var newElement = jQuery(oldElement).clone();
		jQuery(oldElement).attr('id', fileId);
		jQuery(oldElement).before(newElement);
		jQuery(oldElement).appendTo(form);


		
		//set attributes
		jQuery(form).css('position', 'absolute');
		jQuery(form).css('top', '-1200px');
		jQuery(form).css('left', '-1200px');
		jQuery(form).appendTo('body');		
		return form;
    },

    ajaxFileUpload: function(s) {
        // TODO introduce global settings, allowing the client to modify them for all requests, not only timeout		
        s = jQuery.extend({}, jQuery.ajaxSettings, s);
        var id = new Date().getTime()        
		var form = jQuery.createUploadForm(id, s.fileElementId, (typeof(s.data)=='undefined'?false:s.data));
		var io = jQuery.createUploadIframe(id, s.secureuri);
		var frameId = 'jUploadFrame' + id;
		var formId = 'jUploadForm' + id;		
        // Watch for a new set of requests
        if ( s.global && ! jQuery.active++ )
		{
			jQuery.event.trigger( "ajaxStart" );
		}            
        var requestDone = false;
        // Create the request object
        var xml = {}   
        if ( s.global )
            jQuery.event.trigger("ajaxSend", [xml, s]);
        // Wait for a response to come back
        var uploadCallback = function(isTimeout)
		{			
			var io = document.getElementById(frameId);
            try 
			{				
				if(io.contentWindow)
				{
					 xml.responseText = io.contentWindow.document.body?io.contentWindow.document.body.innerHTML:null;
                	 xml.responseXML = io.contentWindow.document.XMLDocument?io.contentWindow.document.XMLDocument:io.contentWindow.document;
					 
				}else if(io.contentDocument)
				{
					 xml.responseText = io.contentDocument.document.body?io.contentDocument.document.body.innerHTML:null;
                	xml.responseXML = io.contentDocument.document.XMLDocument?io.contentDocument.document.XMLDocument:io.contentDocument.document;
				}						
            }catch(e)
			{
				jQuery.handleError(s, xml, null, e);
			}
            if ( xml || isTimeout == "timeout") 
			{				
                requestDone = true;
                var status;
                try {
                    status = isTimeout != "timeout" ? "success" : "error";
                    // Make sure that the request was successful or notmodified
                    if ( status != "error" )
					{
                        // process the data (runs the xml through httpData regardless of callback)
                        var data = jQuery.uploadHttpData( xml, s.dataType );    
                        // If a local callback was specified, fire it and pass it the data
                        if ( s.success )
                            s.success( data, status );
    
                        // Fire the global callback
                        if( s.global )
                            jQuery.event.trigger( "ajaxSuccess", [xml, s] );
                    } else
                        jQuery.handleError(s, xml, status);
                } catch(e) 
				{
                    status = "error";
                    jQuery.handleError(s, xml, status, e);
                }

                // The request was completed
                if( s.global )
                    jQuery.event.trigger( "ajaxComplete", [xml, s] );

                // Handle the global AJAX counter
                if ( s.global && ! --jQuery.active )
                    jQuery.event.trigger( "ajaxStop" );

                // Process result
                if ( s.complete )
                    s.complete(xml, status);

                jQuery(io).unbind()

                setTimeout(function()
									{	try 
										{
											jQuery(io).remove();
											jQuery(form).remove();	
											
										} catch(e) 
										{
											jQuery.handleError(s, xml, null, e);
										}									

									}, 100)

                xml = null

            }
        }
        // Timeout checker
        if ( s.timeout > 0 ) 
		{
            setTimeout(function(){
                // Check to see if the request is still happening
                if( !requestDone ) uploadCallback( "timeout" );
            }, s.timeout);
        }
        try 
		{

			var form = jQuery('#' + formId);
			jQuery(form).attr('action', s.url);
			jQuery(form).attr('method', 'POST');
			jQuery(form).attr('target', frameId);
            if(form.encoding)
			{
				jQuery(form).attr('encoding', 'multipart/form-data');      			
            }
            else
			{	
				jQuery(form).attr('enctype', 'multipart/form-data');			
            }			
            jQuery(form).submit();

        } catch(e) 
		{			
            jQuery.handleError(s, xml, null, e);
        }
		
		jQuery('#' + frameId).load(uploadCallback	);
        return {abort: function () {}};	

    },

    uploadHttpData: function( r, type ) {
        var data = !type;
        data = type == "xml" || data ? r.responseXML : r.responseText;
        // If the type is "script", eval it in global context
        if ( type == "script" )
            jQuery.globalEval( data );
        // Get the JavaScript object, if JSON is used.
        if ( type == "json" )
            eval( "data = " + data );
        // evaluate scripts within html
        if ( type == "html" )
            jQuery("<div>").html(data).evalScripts();

        return data;
    }
})

// end ajaxFileUpload
